\documentclass{tortechrep}
%\documentclass{article}
%\usepackage{palatcm}
%\usepackage{fancyhdr}
\usepackage{color}
\usepackage{graphicx}
%\usepackage{fullpage}
%\setlength{\headheight}{12pt}
%\setlength{\headsep}{12pt}
%\addtolength{\textheight}{-24pt}

\usepackage{prettyref}
\newrefformat{sec}{Section~\ref{#1}}
\newrefformat{tab}{Table~\ref{#1}}
\newrefformat{fig}{Figure~\ref{#1}}
\newrefformat{cha}{Chapter~\ref{#1}}
\newrefformat{eqn}{Equation~\ref{#1}}
\newrefformat{apx}{Appendix~\ref{#1}}

%\usepackage{hyperref}
%\hypersetup{colorlinks, citecolor=MyDarkRed, filecolor=MyDarkBlue, linkcolor=MyDarkRed, urlcolor=MyDarkBlue}

\definecolor{MyDarkBlue}{rgb}{0, 0.0, 0.45}
\definecolor{MyDarkRed}{rgb}{0.45, 0.0, 0}
\definecolor{MyDarkGreen}{rgb}{0, 0.45, 0}
\definecolor{MyLightGray}{gray}{.90}
\definecolor{MyLightGreen}{rgb}{0.5, 0.99, 0.5}

\usepackage{xspace}
\makeatletter
\newcommand{\ie}{i.e.\@\xspace}
\newcommand{\eg}{e.g.\@\xspace}
\newcommand{\cf}{cf.\@\xspace}
\newcommand{\vs}{vs.\@\xspace}
\newcommand{\wrt}{w.r.t.\@\xspace}
\newcommand{\etal}{\textit{et al.\@\xspace}}
\newcommand{\detal}{\textit{et al.}}
\newcommand{\ia}{inter alia\xspace}
\makeatother

\title{Performance Improvements on Tor\\
or,\\Why Tor is slow and what we're going to do about it}

%% Please add your name in here if you contribute
\author{Roger Dingledine and Steven J. Murdoch}
\contact{arma@torproject.org,steven.murdoch@cl.cam.ac.uk}
\date{November 9, 2009}
\reportid{2009-11-001}

%\pagestyle{fancy}
%\fancyhf{}

%\fancyhead[C]{\thetitle}
%\fancyfoot[C]{\thepage}

\begin{document}

%\thispagestyle{plain}

\maketitle

As Tor's user base has grown, the performance of the Tor network has
suffered. This document describes our current understanding of why Tor
is slow, and lays out our options for fixing it.

Over the past few years, our funding (and thus our development effort)
has focused on usability and blocking-resistance.
We've come up with a portable self-contained Windows bundle;
deployed tools to handle the upcoming censorship arms race; further
developed supporting applications like Vidalia, Torbutton, and Thandy;
made it easier for users to be relays by adding better rate limiting and
an easy graphical interface with uPnP support; developed an effective
translation and localization team and infrastructure; and spread
understanding of Tor in a safe word-of-mouth way that stayed mostly
under the radar of censors.

%s we've been adding these features, people around the world have
%ontinued to realize that they want privacy online, and
%Tor's user base has grown larger than the current network can handle.
% At
%the same time, Tor's flexibility in terms of handling many protocols has
%bitten us because a small number of people are loading down the network
%with file sharing traffic.

%Tor remains slow because we're lagging behind in deploying some of
%the new research ideas to handle load better, and because we haven't
%increased the capacity of the network to handle the new load.

In parallel to adding these features, we've also been laying the
groundwork for performance improvements. We've been working with academics
to write research papers on improving Tor's speed, funding
some academic groups directly to come up with prototypes, and
thinking hard about how to safely collect metrics about network
performance. But it's becoming increasingly clear that we're not going
to produce the perfect answers just by thinking hard. We need to roll
out some attempts at solutions, and use the experience to get better
intuition about how to really solve the problems.

%better understanding of anonymity (research)
%Two approaches: "research conclusively first" vs "roll it out and see"

We've identified six main reasons why the Tor network is slow.
Problem \#1 is that Tor's congestion control does not work well. We need
to come up with ways to let ``quiet'' streams like web browsing
co-exist better with ``loud'' streams like bulk transfer.
Problem \#2 is that some Tor users simply put too much traffic onto the
network relative to the amount they contribute, so we need to work on
ways to limit the effects of those users and/or provide priority to the
other users.
Problem \#3 is that the Tor network simply doesn't have enough capacity
to handle all the users that want privacy on the Internet. We need to
develop strategies for increasing the overall community of relays, and
consider introducing incentives to make the network more self-sustaining.
Problem \#4 is that Tor's current path selection algorithms don't actually
distribute load correctly over the network, meaning some relays are
overloaded and some are underloaded. We need
to develop ways to more accurately estimate the properties of each relay,
and also ways for clients to select paths more fairly.
Problem \#5 is that Tor clients aren't as good as they should be at
handling high or variable latency and connection failures. We need better
heuristics for clients to automatically shift away from bad
circuits, and other tricks for them to dynamically adapt their behavior.
Problem \#6 is that low-bandwidth users spend too much of their network
overhead downloading directory information. We've made a serious dent
in this problem already, but more work remains here too.

We discuss each reason more in its own section below. For each section,
we explain our current intuition for how to address the problem,
how effective we think each fix would be, how much effort and risk is
involved, and the recommended next steps, all with an eye to what
can be accomplished in 2009.

While all six categories need to be resolved in order to make the Tor
network fast enough to handle everyone who wants to use it, we've ordered
the sections by precedence. That is, solving the earlier sections will
be necessary before we can see benefits from solving the later sections.

%\pagebreak
\tableofcontents
%\pagebreak

\section{Tor's congestion control does not work well}
\label{sec:congestion}

One of Tor's critical performance problems is in how it combines
high-volume streams with low-volume streams. We need to come up with ways
to let the ``quiet'' streams (like web browsing) co-exist better with the
``loud'' streams (like bulk transfer).

\subsection{TCP backoff slows down every circuit at once}

Tor combines all the circuits going between two Tor relays into a single TCP
connection. This approach is a smart idea in terms of anonymity, since
putting all circuits on the same connection prevents an observer from
learning which packets correspond to which circuit. But over the past
year, research has shown that it's a bad idea in terms of performance,
since TCP's backoff mechanism only has one option when that connection
is sending too many bytes: slow it down, and thus slow down all the
circuits going across it.

We could fix this problem by switching to a design with one circuit per
TCP connection. But that means that a relay with 1000 connections and
1000 circuits per connection would need a million sockets open. That
number is a problem for even the well-designed operating systems and
routers out there.

More generally,
Tor currently uses two levels of congestion avoidance -- TCP flow control
per-link, and a simple windowing scheme per-circuit.
It has been suggested that this approach is causing performance problems,
because the two schemes interact badly.

Experiments show that moving congestion management to be fully end-to-end
offers a significant improvement in performance.

There have been two proposals to resolve this problem, but their
underlying principle is the same: use an unreliable protocol for links
between Tor relays, and perform error recovery and congestion management
between the client and exit relay. Tor partially funded Joel Reardon's
thesis~\cite{reardon-thesis} under Ian Goldberg. His thesis proposed
using DTLS~\cite{DTLS}
(a UDP variant of TLS) as the link protocol and a cut-down version of
TCP to give reliability and congestion avoidance, but largely using the
existing Tor cell protocol.
Csaba Kiraly \detal~\cite{tor-l3-approach} proposed using
IPSec~\cite{ipsec} to replace the entire Tor cell and link protocol.

Each approach has its own strengths and weaknesses.
DTLS is relatively immature, and Reardon noted deficiencies in the
OpenSSL implementation of the protocol.
However, the largest missing piece from this proposal is a high-quality,
privacy preserving TCP stack, under a compatible license.
Prior work has shown that there is a substantial privacy leak from TCP
stack and clockskew fingerprinting~\cite{tcptiming,HotOrNot}.
Therefore to adopt this proposal, Tor would need to incorporate a
TCP stack, modified to operate in user-mode and to not leak identity
information.

Reardon built a prototype around the TCP-Daytona stack~\cite{daytona},
developed at IBM Labs, and based on the Linux kernel TCP stack.
This implementation is not publicly available and its license is unclear,
so it is unlikely to be suitable for use in Tor.
Writing a TCP stack from scratch is a substantial undertaking, and
therefore other attempts have been to move different operating system
stacks into user-space.
While there have been some prototypes, the maturity of these systems
have yet to be shown.

Kiraly \etal rely on the operating system IPsec stack, and a modification
to the IKE key exchange protocol to support onion routing.
As with the proposal from Reardon, there is a risk of operating system
and machine fingerprinting from exposing the client TCP stack to the
exit relay.
This could be resolved in a similar way, by implementing a user-mode
IPsec stack, but this would be a substantial effort, and would lose some
of the advantages of making use of existing building blocks.

%A significant issue with moving from TLS as the link protocol is that
%it is incompatible with Tor's current censorship-resistance strategy.
%Tor impersonates the TLS behaviour of HTTPS web-browsing, with the
%intention that it is difficult to block Tor, without blocking a
%significant amount of HTTPS.
%If Tor were to move to an unusual protocol, such as DTLS, it would be
%easier to block just Tor.
%Even IPsec is comparatively unusual on the open Internet.

%One option would be to modify the link protocol so that it impersonates
%an existing popular encrypted protocol.
%To avoid requiring low-level operating system access, this should be a
%UDP protocol.
%There are few options available, as TCP is significantly more popular.
%Voice over IP is one fruitful area, as these require low latency and
%hence UDP is common, but further investigation is needed.

Prof.~Goldberg has a new student named Chris Alexander picking up
where Joel left off. He's
currently working on fixing bugs in OpenSSL's implementation of DTLS along
with other core libraries that we'd need to use if we go this direction.

{\bf Impact}: High.

{\bf Effort}: High effort to get all the pieces in place.

{\bf Risk}: High risk that it would need further work to get right.

{\bf Plan}: We should keep working with them (and help fund Chris)
to get this project closer
to something we can deploy. The next step on our side is to deploy
a separate testing Tor network that uses datagram protocols, based on
patches from Joel and others, and get more intuition from that. We could
optimistically have this testbed network deployed in late 2009.

\subsection{We chose Tor's congestion control window sizes wrong}
%Changing circuit window size

Tor maintains a per-circuit maximum of unacknowledged cells
(\texttt{CIRCWINDOW}).
If this value is exceeded, it is assumed that the circuit has become
congested, and so the originator stops sending.
Kiraly proposed~\cite{circuit-window,tor-l3-approach} that reducing
this window size would substantially decrease latency (although not
to the same extent as moving to an unreliable link protocol), while not
affecting throughput.

Specifically, right now the circuit window size is 512KB and the
per-stream window size is 256KB. These numbers mean that a user
downloading a large file receives it (in the ideal case) in chunks
of 256KB, sending back acknowledgements for each chunk. In practice,
though, the network has too many of these chunks moving around at once,
so they spend most of their time waiting in buffers at relays.

Reducing the size of these chunks has several effects. First, we reduce
memory usage at the relays, because there are fewer chunks waiting and
because they're smaller. Second, because there are fewer bytes vying to
get onto the network at each hop, users should see lower latency.

More investigation is needed on precisely what should be the new value
for the circuit window, and whether it should vary.
Out of 100KB, 512KB (current value in Tor) and 2560KB, they found the
optimum was 100KB for all levels of packet loss.
However this was only evaluated for a fixed network latency and relay
bandwidth, where all users had the same \texttt{CIRCWINDOW} value.
Therefore, a different optimum may exist for networks with different
characteristics, and during the transition of the network to the new value.

{\bf Impact}: Medium. It seems pretty clear that in the steady-state this
patch is a good idea; but it's still up in the air whether the transition
period will show immediate improvement or if there will be a period
where traffic from people who upgrade get clobbered by traffic from
people who haven't upgraded yet.

{\bf Effort}: Low effort to deploy -- it's a several line patch!

{\bf Risk}: Medium risk that we haven't thought things through well
enough and we'd need to back it out or change parts of it.

{\bf Plan}: Once we start on Tor 0.2.2.x (in the next few months), we should
put the patch in and see how it fares. We should go for maximum effect,
and choose the lowest possible window setting of 100 cells (50KB).

%\subsection{Priority for circuit control cells, e.g. circuit creation}

\section{Some users add way too much load}
\label{sec:too-much-load}

\prettyref{sec:congestion} described mechanisms to let low-volume
streams have a chance at competing with high-volume streams. Without
those mechanisms, normal web browsing users will always get squeezed out
by people pulling down larger content and tolerating high latency. But the next problem is that some
users simply add more load than the network can handle. Just making sure
that all the load gets handled fairly isn't enough if there's too much
load in the first place.

When we originally designed Tor, we aimed for high throughput. We
figured that providing high throughput would mean we get good latency
properties for free. However, now that it's clear we have several user
profiles trying to use the Tor network at once, we need to consider
changing some of those design choices. Some of those changes would aim
for better latency and worse throughput.

\subsection{Squeeze over-active circuits}
\label{sec:squeeze}

The Tor 0.2.0.30 release included this change:
\begin{verbatim}
  - Change the way that Tor buffers data that it is waiting to write.
    Instead of queueing data cells in an enormous ring buffer for each
    client->relay or relay->relay connection, we now queue cells on a
    separate queue for each circuit. This lets us use less slack memory,
    and will eventually let us be smarter about prioritizing different
    kinds of traffic.
\end{verbatim}

Currently when we're picking cells to write onto the network, we choose
round-robin from each circuit that wants to write. We could instead
remember which circuits have written many cells recently, and give priority
to the ones that haven't.

Technically speaking, we're reinventing more of TCP here, and we'd be
better served by a general switch to DTLS+UDP. But there are two reasons
to still consider this separate approach.

The first is rapid deployment. We could get this change into the Tor 0.2.2.x
development release in mid 2009, and as relays upgrade, the change would
gradually phase in. This timeframe is way earlier than the practical
timeframe for switching to DTLS+UDP.

The second reason is the flexibility this approach provides. We could
give priorities based on recent activity (``if you've sent much more
than the average in the past 10 seconds, then you get slowed down''),
or we could base it on the total number of bytes sent on the circuit so
far, or some combination. Even once we switch to DTLS+UDP, we may still
want to be able to enforce some per-circuit quality-of-service properties.

This meddling is tricky though: we could encounter feedback effects if
we don't perfectly anticipate the results of our changes. For example,
we might end up squeezing certain classes of circuits too far, causing
those clients to build too many new circuits in response.
Or we might simply squeeze all circuits too much, ruining the network
for everybody.
% XXX

Also, Bittorrent is designed to resist attacks like this -- it
periodically drops its lowest-performing connection and replaces it with
a new one. So we would want to make sure we're not going to accidentally
increase the number of circuit creation requests and thus just shift
the load problem.

{\bf Impact}: High, if we get it right.

{\bf Effort}: Medium effort to deploy -- we need to go look at the code
to figure out where to change, how to efficiently keep stats on which
circuits are active, etc.

{\bf Risk}: High risk that we'd get it wrong the first few times. Also,
it will be hard to measure whether we've gotten it right or wrong.

{\bf Plan}: Step one is to evaluate the complexity of changing the
current code. We should do that for Tor 0.2.2.x in mid 2009. Then we should
write some proposals for various meddling we could do, and try to find
the right balance between simplicity (easy to code, easy to analyze)
and projected effect.

\subsection{Throttle certain protocols at exits}

If we're right that Bittorrent traffic is a main reason for Tor's load,
we could bundle a protocol analyzer with the exit relays. When they
detect that a given outgoing stream is a protocol associated with bulk
transfer, they could set a low rate limit on that stream. (Tor already
supports per-stream rate limiting, though we've never found a need for
it.)

This is a slippery slope in many respects though. First is the wiretapping
question: is an application that automatically looks at traffic content
wiretapping? It depends which lawyer you ask. Second is the network
neutrality question: remember Comcast's famous ``we're just delaying
the traffic'' quote. Third is the
liability concern: once we add this feature in, what other requests are
we going to get for throttling or blocking certain content? And does the
capability to throttle certain content change the liability situation
for the relay operator?
%(Imagine an AG, ``I demand you block all things immoral, or provide me
%the API to do it myself; you clearly have the ability.  Also anyone who
%doesn't is going to get served.'')

{\bf Impact}: Medium-high.

{\bf Effort}: Medium effort to deploy: need to find the right protocol
recognition tools and sort out how to bundle them.

{\bf Risk}: This isn't really an arms race we want to play. The
``encrypted bittorrent'' community already has a leg up since they've been
fighting this battle with the telco's already. Plus the other downsides.

{\bf Plan}: Not a good move.

\subsection{Throttle certain protocols at the client side}

While throttling certain protocols at the exit side introduces wiretapping
and liability problems, detecting them at the client side is more
straightforward. We could teach Tor clients to detect protocols as they
come in on the socks port, and automatically treat them differently --
and even pop up an explanation box if we like.

This approach opens a new can of worms though: clients could disable the
``feature'' and resume overloading the network.

{\bf Impact}: Medium-high.

{\bf Effort}: Medium effort to deploy: need to find the right protocol
recognition tools and sort out how to bundle them.

{\bf Risk}: This isn't really an arms race we want to play either. Users
who want to file-share over Tor will find a way. Encouraging people
to fork a new ``fast'' version of Tor is not a good way to keep all
sides happy.

{\bf Plan}: Not a good move.

\subsection{Throttle all streams at the client side}

While we shouldn't try to identify particular protocols as evil, we
could set stricter rate limiting on client streams by default. If we
set a low steady-state rate with a high bucket size (\eg allow spikes
up to 250KB but enforce a long-term rate for all streams of 5KB/s),
we would probably provide similar performance to what clients get now,
and it's possible we could alleviate quite a bit of the congestion and
then get even better and more consistent performance.

Plus, we could make the defaults higher if you sign up as a relay and
pass your reachability test.

The first problem is: how should we choose the numbers? So far we have
avoided picking absolute speed numbers for this sort of situation,
because we won't be able to predict a number now which will still be
the correct number in the future.

The second problem is the same as in the previous subsection -- users
could modify their clients to disable these checks. So we would want
to do this step only if we also put in throttling at the exits or
intermediate relays, a la \prettyref{sec:squeeze}. And if that throttling
works, changing clients
(and hoping they don't revert the changes) may be unnecessary.

{\bf Impact}: Low at first, but medium-high later.

{\bf Effort}: Low effort to deploy.

{\bf Risk}: If we pick high numbers, we'll never see much of an impact.
If we pick low numbers, we could accidentally choke users too much.

{\bf Plan}: It's not crazy, but may be redundant. We should consider
in Tor 0.2.2.x whether to do it, in conjunction with throttling at other
points in the circuit.

\subsection{Default exit policy of 80,443}

We hear periodically from relay operators who had problems with DMCA
takedown attempts, switched to an exit policy of ``permit only ports 80
and 443'', and no longer hear DMCA complaints.

Does that mean that most file-sharing attempts go over some other port? If
only a few exit relays permitted ports other than 80 and 443, we would
effectively squeeze the high-volume flows onto those few exit relays,
reducing the total amount of load on the network.

First, there's a clear downside: we lose out on other protocols. Part
of the point of Tor is to be application-neutral. Also, it's not clear
that it would work long-term, since corporate firewalls are continuing
to push more and more of the Internet onto port 80.

To be clearer, we have more options here than the two extremes. We could
switch the default exit policy from allow-all-but-these-20-ports to
accept-only-these-20-ports. We could even get more complex, for example
by applying per-stream rate limiting at the exit relays to streams
destined for certain ports.

{\bf Impact}: Low? Medium? High?

{\bf Effort}: Low effort to deploy.

{\bf Risk}: The Tor network becomes less useful, roughly in proportion
to the amount of speedup we get.

{\bf Plan}: I think we should take some of these steps in the Tor 0.2.2.x
timeframe. The big challenge here is that we don't have much intuition
about how effective the changes should be, so we don't know how far to go.

\subsection{Better user education}

We still run across users who think any anonymity system out there must
have been designed with file-sharing in mind. If we make it clearer in
the FAQ and our webpage that Tor isn't for high-volume streams, that
might combine well with the other approaches above.

Overall, the challenge of users who want to overload the system will
continue. Tor is not the only system that faces this challenge.

\section{The Tor network doesn't have enough capacity}
\label{sec:capacity}

\prettyref{sec:congestion} aims to let web browsing
connections work better in the face of high-volume streams, and
\prettyref{sec:too-much-load} aims to reduce the overall load on the
network. The third reason why Tor is slow is that we simply don't have
enough capacity in the network to handle all the users who want to use Tor.

Why do we call this the third problem rather than the number one
problem? Just adding more capacity to the network isn't going to solve
the performance problem. If we add more capacity without solving the
issues with high-volume streams, then those high-volume streams will
expand to use up whatever new capacity we add.

Economics tells us to expect that improving performance in the Tor network
(\ie increasing supply) means that more users will arrive to fill the
void. So in either case we shouldn't be under the illusion that Tor will
magically just become faster once we implement these improvements.
We place the first two sections higher in priority because their goals are
to limit the ability of the high-volume users to become even higher-volume
users, thus allowing the new capacity to be more useful to the other users.
We discuss the supply-vs-demand question more in \prettyref{sec:economics}.

\subsection{Tor server advocacy}

Encouraging more volunteers to run Tor servers, and existing volunteers
to keep their servers running, will increase network capacity and
hence performance.

{\bf Impact}: High, assuming we work on the plans from
\prettyref{sec:congestion} and \prettyref{sec:too-much-load} also.

{\bf Effort}: Medium to high, depending on how much we put in.

{\bf Risk}: Low.

{\bf Plan}: A clear win. We should do as many advocacy aspects as we
can fit in.

\subsubsection{Talks and trainings}

One of the best ways we've found for getting new relays is to go to
conferences and talk to people in person. There are many thousands of
people out there with spare fast network connections and a willingness
to help save the world. Our experience is that visiting them in person
produces much better results, long-term, than Slashdot articles.

Roger and Jake have been working on this angle, and Jake will be ramping
up even more on it in 2009.

Advocacy and education is especially important in the context of new and
quickly-changing government policies. In particular, the data retention
question in Germany is causing instability in the overall set
of volunteers willing to run relays. Karsten's latest
metrics\footnote{\url{https://metrics.torproject.org/}}
show that while the number
of relays in other countries held steady or went up during 2008, the
numbers in Germany went down over the course of 2008. On the other hand,
the total amount of bandwidth provided by German relays held steady
during 2008 -- so while other operators picked up the slack, we still
lost overall diversity of relays. These results tell us where to focus
our efforts.

\subsubsection{Better support for relay operators}

Getting somebody to set up a relay is one thing; getting them to keep it
up is another thing entirely. We lose relays when the operator reboots
and forgets to set up the relay to start on boot. We lose relays when
the operator looks through the website and doesn't find the answer to
a question.

%When the Tor network was just starting out, Roger interacted with each
%relay operator and tried to be responsive to all issues. The network
%quickly scaled beyond his ability to provide enough attention to each
%operator.

We've been working on a new service for relay operators called Tor
Weather\footnote{\url{https://weather.torproject.org/}}. The idea is
that once you've set up your relay, you can subscribe to get an email
whenever it goes down. We need to work on the interface more, for example to
let people subscribe to various levels of notification, but the basic
idea seems like a very useful one.

With Tor Weather you can also subscribe to watch somebody \emph{else}'s
relay; so this service should tie in well for the people doing advocacy,
to let them focus their follow-ups when a relay they helped set up
disappears.

We are also considering setting up a mailing list exclusively for relay
operators, to give them a better sense of community, to answer questions
and concerns more quickly, etc.

We should also consider offering paid or subsidized support options so
relay operators have a place to go for help. Corporations and universities
running relays could get direct phone, email, or IM support options.

\subsubsection{A Facebook app to show off your relay}

We're currently developing a Facebook
application that will allow relay operators to link their Tor relays
to their Facebook profile. Volunteers who desire can therefore publicly
get credit for their contribution to the Tor network. This would raise
awareness for Tor, and encourage others to operate relays.

Opportunities for expansion include allowing relay operators to form
``teams'', and for these teams to be ranked on the contribution to the
network. (Real world examples here include the SETI screensaver and the
MD5 hash crack challenges.) This competition may give more encouragement
for team members to
increase their contribution to the network. Also, when one of the team
members has their relay fail, other team members may notice and provide
assistance on fixing the problem.
% Would this also introduce an incentive to cheat to be the top team?) -AL
% Yes. -RD

\subsubsection{Look for new ways to get people to run relays}

We are not primarily social engineers, and the people that we are good
at convincing to set up relays are not a very huge group.

We need to keep an eye out for more creative ways to encourage a broader
class of users to realize that helping out by operating a relay will
ultimately be something they want to do.

\subsection{Funding more relays directly}

Another option is to directly pay hosting fees for fast relays (or
to directly sponsor others to run them).

The main problem with this approach is that the efficiency is low: at
even cheap hosting rates, the cost of a significant number of new relays
grows quickly. For example, if we can find 100 non-exit relays providing
1MB/s for as low as \$100/mo (and at that price it'd be renting space
on a shared server, with all the resource sharing hassles that comes
with), that's \$120k per year. Figure some more
for maintenance and coordination, the overhead to find 100 locations
that are on sufficiently different networks and administrative zones, etc.

The amount of work involved in running them as exit relays might be a
few times this cost, due to higher hosting fees, more effort involved
in establishing and maintaining the right relationships, having lawyers
nearby, etc.

Plus the costs just keep coming, month after month.

Overall, it seems more sustainable to invest in better code, and community
outreach and education.

{\bf Impact}: Medium.

{\bf Effort}: High.

{\bf Risk}: Low.

{\bf Plan}: If we end up with extra funding, sure. Otherwise, I think
our time and effort are better spent on design and coding that will
have long-term impact rather than be recurring costs.

\subsection{Handling fast Tor relays on Windows}
\label{sec:overlapped-io}

Advocating that users set up relays is all well and good, but if most
users are on Windows, and Tor doesn't support fast relays on Windows
well, then we're in a bad position.

Nick has been adapting libevent so it can handle a buffer-based
abstraction rather than the traditional Unix-style socket-based
abstraction. Then we will modify Tor to use this new abstraction. Nick's
blog post\footnote{\url{https://blog.torproject.org/blog/some-notes-progress-iocp-and-libevent}}
provides more detail.

{\bf Impact}: Medium.

{\bf Effort}: High, but we're already halfway through.

{\bf Risk}: Low.

{\bf Plan}: Keep at it. We're on schedule to get a test version (one that
works for Nick) out in September 2009. Then iterate until it works
for everybody.

\subsection{Relay scanning to find overloaded relays or broken exits}
\label{sec:relay-scanning}

Part of the reason that Tor is slow is because some of the relays are
advertising more bandwidth than they can realistically handle. These
anomalies might be due to bad load balancing on the part of the Tor
designers, bad rate limiting or flaky network connectivity on the part
of the relay operator, or malicious intent. Similarly, some exit relays
might fail to give back the `real' content, requiring users to repeat
their connection attempts.

Mike has been working on tools to
identify these relays: SpeedRacer\footnote{\url{https://gitweb.torproject.org/torflow.git/blob/HEAD:/NetworkScanners/BwAuthority/README.BwAuthorities}}
and SoaT\footnote{\url{https://gitweb.torproject.org/torflow.git/blob/HEAD:/NetworkScanners/ExitAuthority/README.ExitScanning}}.
Once the tools are further refined, we should be able to figure out if
there are general classes of problems (load balancing, common usability
problems, etc) that mean we should modify our design to compensate. The
end goal is to get our tools to the point where they can automatically
tell the directory authorities to leave out certain misbehaving relays in
the network status consensus, and/or adjust the bandwidths they advertise
for each relay.

{\bf Impact}: Low.

{\bf Effort}: Medium.

{\bf Risk}: Low.

{\bf Plan}: Keep at it. We're on schedule to get a test version
(that works for Mike) out in mid 2009. Then iterate until it works
for everybody.

\subsection{Getting dynamic-IP relays back into the relay list quickly}

Currently there is a delay of 2-5 hours between when a relay changes its
IP address and when that relay gets used again by clients. This delay
causes two problems: relays on dynamic IP addresses will be underutilized
(contributing less to the total network capacity than they could),
and clients waste time connecting to relay IP addresses that are no
longer listening.

There are several approaches that can mitigate this problem by notifying
clients sooner about IP address changes.
The first approach is to continue on our path of simplifying directory
information (see \prettyref{sec:directory-overhead}): if we can put out
``diffs'' of the network status more often than once an hour, clients
can get updated quicker.
A second approach is for each relay to estimate how volatile its IP address
is, and advertise this in its descriptor.
Clients then ignore relays with volatile IP addresses and old descriptor.
Similarly, directory authorities could prioritise the distribution of
updated IP addresses for freshly changed relays.

As a last note here, we currently have some bugs that are causing relays
with dynamic IP addresses to fall out of the network entirely. If a
third to half of the relays are running on dynamic IP addresses, that's
really bad.

{\bf Impact}: Low-medium.

{\bf Effort}: Low-medium.

{\bf Risk}: Low.

{\bf Plan}: Track down and fix bugs for Tor 0.2.2.x. Continue simplifying
directory information so we can get new info to clients quicker.

\subsection{Incentives to relay}

Our blog post on this
topic\footnote{\url{https://blog.torproject.org/blog/two-incentive-designs-tor}}
explains
our work to-date on this topic. The current situation is that we have
two designs to consider: one that's quite simple but has a serious
anonymity problem, and one that's quite complex.

I think we should move forward with the first (simple but flawed)
design. There are several pieces to moving it forward. The first phase
is changing Tor's queueing mechanisms to be able to give some circuits
priority over others. This step also ties into the other development items
in this document regarding cell-, circuit-, and connection-priorities. The
second phase is then redesigning the ``gold star'' mechanism so the
priority earned by relays lasts long enough that there's a sufficient
anonymity set for them. We'll need to look at current and projected
network metrics to discover a good upper bound on relay churn. The
question to answer is: ``What period of time, taken as a rolling snapshot
of which relays are present in the network, guarantees a sufficiently
large anonymity set for high-priority relays?'' Hopefully the answer is
something like 7 or 14 days. There are other missing pieces in there, like
``what do we mean by sufficiently?'', that we'll just have to guess about.
The third phase is to actually sort out how to construct and distribute
gold-star cryptographic certificates that entry relays can verify.

Notice that with the new certificates approach, we can reward users
who contribute to the network in other ways than running a fast public
relay -- examples might include top sponsors, users who run stable bridge
relays, translators, people who fix bugs, etc.

{\bf Impact}: Medium-high.

{\bf Effort}: Medium-high.

{\bf Risk}: Medium-high: if we screw up the balance of our
community-oriented infrastructure, we might end up hurting more than
we help.

{\bf Plan}: Accomplishing the three phases above will put us in a much
better position to decide whether to deploy this idea. At the same time,
the more complex options might become more within reach as other research
teams investigate and refine them, so we should keep an eye on them too.

\subsection{Reachable clients become relays automatically}

Even if we don't add in an incentive scheme, simply making suitable
users into relays by default should do a lot for our capacity problems.

We've made many steps toward this goal already, with automated
reachability testing, bandwidth estimation, UPnP support built in to
Vidalia, and so on.

There are a few risks here though. First, relaying traffic could
introduce anonymity vulnerabilities, and we need to learn more about
that first. (That's on the roadmap for 2009.) Second, making clients
into relays by default could make some users upset. Third, this
approach could change how sysadmins view Tor. By putting ourselves
into the same category as Skype, we would scale up the ``blocking
Tor connections'' arms race by a level that's hard to predict.
Also, we need to finish deployment of \prettyref{sec:overlapped-io}
before we can roll this out, or we'll just make a bunch of Windows
machines crash.

We had originally been avoiding the ``everybody a relay'' design until
we had a better plan for scaling the directory to be able to distribute
tens of thousands of relay addresses. I think these two plans are not as
related as we first thought, though. For example, a very simple answer
for what to do if we get more relays than our current directory scheme
can handle is to publish only the best relays, for some metric of best
that considers capacity, expected uptime, etc. That should be a perfectly
adequate stopgap measure. The step after that would be to consider
splintering the network into two networkstatus documents, and clients
flip a coin to decide which they use. Ultimately, if we are so lucky as
to get into the position of having too many relays, we'll want to look
at the distribution and properties of the relays we have when deciding
what algorithms would best make use of them.

{\bf Impact}: High.

{\bf Effort}: Medium, now that we've done a lot of hard work already.

{\bf Risk}: Medium.

{\bf Plan}: Wrap up our investigations into the anonymity implications
of being a relay, at the same time as working on a plan for exactly how
the Tor client should decide if it's suitable for elevation to relay
status. This is going to happen, it's just a matter of how soon.

\section{Tor clients choose paths imperfectly}

Even when we sort out the congestion control issues, the problem of users
abusing the network with too much traffic, and the question of overall
capacity, we still face a fourth problem. Users need to choose their
paths in such a way that everybody is using the network efficiently.

Right now, Tor relays estimate their capacity by observing the largest
traffic burst they've seen themselves do in the past day. They advertise
that bandwidth capacity in the directory information, and clients weight
their path selection by the bandwidth of each relay. For example, a relay
that advertises 100KB/s peak bandwidth will be chosen twice as often as
a relay that advertises 50KB/s peak bandwidth.

There are several problems with our current algorithm that are worth
fixing.

\subsection{We don't balance traffic over our bandwidth numbers correctly}
\label{sec:bias-toward-faster}

Selecting relays with a probability proportional to their bandwidth
contribution to the network may not be the optimal algorithm. Murdoch
and Watson~\cite{murdoch-pet2008} investigated the performance impact of
different relay selection algorithms, and came up with a model to describe
the optimal path selection strategies based on how loaded the network is.

Tor's current selection strategy is optimal when the network is
fully loaded. That is, if every single byte is going to be used, then
weighting by capacity is the right way to do it. But if the network is
not fully loaded, then the fast relays end up with less load than the
slow relays. To compensate, clients should pick faster relays with
higher probability.

In particular, we can estimate the network load because all Tor relays
publish both their capacity and usage in their relay descriptor (but
see \prettyref{sec:better-bandwidth-estimates} for problems that crop
up there). The Tor network
is currently loaded at around 50\%. This level is much higher than most
reasonable networks, indicating that our plan in \prettyref{sec:capacity}
to get more overall capacity is a good one. But 50\% is quite far from
100\% when it becomes to optimal load balancing.

%, and derived a formula
%for estimating average latency $T$:

%\begin{equation}
%T = \sum_{i=1}^n q_i t_i = \sum_{i=1}^n \frac{q_i x_i (2 - q_i x_i \Lambda)}{2 (1 - q_i x_i \Lambda)}
%\label{eqn:waiting}
%\end{equation}

%Where $q_i$ is the probability of the $i$th relay (out of $n$ relays) being selected, $t_i$ is the average latency at the $i$th relay, $x_i$ is the reciprocal of the $i$th relay's bandwidth, and $\Lambda$ is the total network load.

%This calculation is subject to a number of assumptions.
%In particular, it assumes that Tor relays have infinite length queues and input traffic is Poisson distributed.
%Whereas in practice Tor relays have finite length queues (which controls network load), and the distribution of input cells is not known.
%Unfortunately, these assumptions are necessary to apply standard queueing theory results.

To find the optimum relay selection probabilities for the model, Steven
used a hill-climbing algorithm to minimize network latency, with a Tor
directory snapshot as input.
The results (shown in \prettyref{fig:optimum-selection} and
\prettyref{fig:relative-selection}) depend on the network load relative
to overall capacity.
As load approaches capacity, the optimum selection probabilities
converge to the one currently used by Tor: relay bandwidth proportional
to network capacity.
However, as load drops, the optimized selection algorithm favors slow
relays less and faster relays more; many relays are not used at all.

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{node-selection/optimum-selection-probabilities}
\caption{Optimum relay selection probabilities for a variety of network loads. Tor is currently at around 50\% utilization. The relay selection probabilities currently used by Tor are shown in black.}
\label{fig:optimum-selection}
\end{figure}

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{node-selection/relative-selection-probabilities}
\caption{Difference between Tor's current relay selection probabilities and the optimum, for a variety of network loads. For Tor's current network load ($\approx 50$\%) shown in pink, the slowest relays are not used at all, and the slower relays are favoured less.}
\label{fig:relative-selection}
\end{figure}

%\subsubsection{Impact of network load estimation}

Anecdotal evidence supports the theory that the fast relays in the Tor
network have more spare capacity than they should. Several users have
posted that they get much better Tor performance if they hard-code their
paths to only use the fastest ten relays (and ignore the huge anonymity
implications, of course).
% Snader and Borisov~\cite{tuneup} suggested
%an alternate strategy for relay selection that put even more weight on
%the fast relays, and justified their design by trying it on the current
%Tor network. Our current theory is that their alternate strategy puts
%too much weight on the fast relays if all clients were doing it, and
%it only looked good because the current network is unbalanced; but as
%usual more research remains to get better intuition there.

The relay selection probabilities in these graphs are tuned to a
particular level of network load. \prettyref{fig:vary-load} shows how
average network latency is affected by relay selection probabilities,
for different levels of network load. For all load levels examined,
the optimized selection probabilities offer lower latency when compared
to Tor's current selection algorithm. However, there's a downside to
tailoring for a particular load level: if we see a much heavier load in
practice than the one we had in mind when we tuned our selection biases,
then we end up overbalancing the network in the other direction.

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{node-selection/vary-network-load}
\caption{Average network latency against network load. Three relay selection probabilities are shown, optimized for 50\%, 75\%, and 90\% network load. The Tor relay selection algorithm is also included (black). The dots on the $x$ axis show the level of network load at which the relay selection probability distributions are optimized for. The line is cut off when the model predicts that at least one relay will have an infinite queue length, which occurs before load $=$ capacity for all relay selection algorithms except for Tor's current one.}
\label{fig:vary-load}
\end{figure}

Specifically, each probability distribution has a cut-off point at
which (according to the model) at least one relay will have a higher
load than its capacity, at which its queue length, and hence latency,
will become infinite.
For the optimized selection probability distributions, this cut-off
point is a few percent above the level they were designed to operate at.
For Tor's current selection algorithm, it is when the overall network
capacity equals the overall network load.

In this respect the Tor selection algorithm reaches the theoretical
optimum, as no network can operate at greater than 100\% utilization
while maintaining finite latency.
However, in a real instantiation of any of these alternative probability
distributions, the network latency would not become infinite; instead
a connection would time out and a different circuit would be selected.
So in practice, if the wrong probability distribution was selected,
the network would converge at a different one.
Unfortunately the standard queuing theory models cannot handle this
case; we need to move to a simulation rather than using equations
and assumptions, to estimate the real effect.

{\bf Impact}: Low-medium.

{\bf Effort}: Medium, since we still need to get a better sense of
the correct network load to expect, and we need to experiment to see
if the model actually matches reality.

{\bf Risk}: Low, since we can always back out the changes.

{\bf Plan}: It seems clear that some adjustments should be done in
terms of biasing selection toward the faster relays. The exact load
level to anticipate remains an open question though. Fortunately, in
our new networkstatus algorithm, the directory authorities declare the
bandwidths for each relay. So we can just reweight them on the fly and
clients will use the new numbers. That means once enough clients have
upgraded to using the bandwidths specified in the networkstatus, we can
start to experiment with shifting the biases and see what results we get.

%Despite the simplifications made to the network model, results derived
%from it may still be useful.
%This is especially the case because it models the entire network, whereas
%experiments can feasibly change only a few of the clients' behaviour.
%The formula is also amenable to mathematical analysis such as non-linear
%optimization.

\subsection{The bandwidth estimates we have aren't very accurate}
\label{sec:better-bandwidth-estimates}

Weighting relay selection by bandwidth only works if we can accurately
estimate the bandwidth for each relay.

Snader and Borisov~\cite{tuneup} examined three strategies for estimating
the bandwidth for each relay. The first strategy was Tor's current
approach of looking for peaks in the actual bytes it's handled in the past
day. The second strategy was active probing by the directory authorities.
For their third strategy, they proposed that each Tor relay
opportunistically monitor the data rates that it achieves when
communicating with other Tor relays.
Since currently Tor uses a clique topology, given enough time, all relays
will communicate with all other Tor relays.
If each Tor relay reports their measurements back to the directory
authorities, then the median report should be a good estimate of that
relay's bandwidth.
As a bonus, this estimate should be difficult to game, when compared to
the current approach of self-advertising bandwidth capacity.

Experiments show that opportunistic bandwidth measurement has a better
systematic error than Tor's current self-advertised measure, although
has a poorer log-log correlation (0.48 vs. 0.57).
The most accurate scheme is active probing of capacity, with a log-log
correlation of 0.63, but this introduces network overhead.

All three schemes suffer from fairly poor accuracy. Perhaps this
inaccuracy is due to some relays with high variance in bandwidth
capacity? We need to explore this area more to understand why our
estimates are not as good as they could be.

{\bf Impact}: Low-medium.

{\bf Effort}: Medium, since we still need to get a better sense of
the correct network load to expect, and we need to experiment to see
if the model actually matches reality.

{\bf Risk}: Low, since we can always back out the changes.

{\bf Plan}: More research remains here to figure out what algorithms
will actually produce more accurate bandwidth estimates. As with
\prettyref{sec:bias-toward-faster} above, once we do have some better
numbers, we can change the weights in the directory, and clients will
immediately move to the better numbers. We should also experiment with
augmenting our estimates with active probes from Mike's SpeedRacer tool.

\subsection{Bandwidth might not even be the right metric to weight by}

The current Tor network selection algorithm biases purely by bandwidth.
This approach will sometimes cause high latency circuits due to multiple
ocean crossings or otherwise congested links.
An alternative approach would be to not only bias selection of relays
based on bandwidth, but to also bias the selection of hops based on
expected latency.

%One option would be to predict the latency of hops based on geolocation
%of the relay IP address.
%This approach has the advantage of not requiring any additional
%measurement database to be published.
%However, it does assume that the geolocation database is accurate and
%that physical distance between hops is an accurate estimator for latency.
%% Micah Sherr tells me that latency and geolocation distance are
%% pretty much not correlated. -RD

Micah Sherr is finishing his PhD thesis at Penn under Matt Blaze,
exploring
exactly this issue. In the past we've avoided any sort of path selection
algorithm that requires pairwise measurements of the network, because
communicating $N^2$ measurements to clients would take too much bandwidth.
Micah solves this problem by using a \emph{virtual coordinate system} --
a three or four dimension space such that distance between relays in
the virtual coordinate space corresponds to the network latency (or other
metric) between them.

His experiments show that we could see a significant speedup in the Tor
network if users choose their paths based on this new relay selection
algorithm. More research remains, of course, but the initial results
are very promising.

%A second option would be to actually measure hop latency, and publish
%the database.
%Nodes could do this themselves and include the results in their descriptor.
%Alternatively, a central authority could perform the measurements and
%publish the results.
%Performing these measurements would be a $O(n^2)$ problem, where $n$
%is the number of relays, so does not scale well.

%Publishing a latency database would also increase the size of the
%directory that each client must download.
%If na\"{\i}vely implemented, the database would scale with $O(n^2)$.
%However, a more efficient versions could be created, such as by dimension
%reduction, creating a map in which the distance between any two relays
%is an approximation of the latency of a hop between them.
%Delta compression could be used if the map changes slowly.

On the other hand, reducing the number of potential paths would also
have anonymity
consequences, and these would need to be carefully considered.
For example, an attacker who wishes to monitor traffic could create
several relays, on distinct /16 subnets, but with low latency between them.
A Tor client trying to minimize latency would be more likely to select
these relays for both entry and exit than it would otherwise.
This particular problem could be mitigated by selecting entry and
exit relay as normal, and only using latency measurements to select the
middle relay.

{\bf Impact}: Medium-high.

{\bf Effort}: Medium-high, since we first need to sort out how effective
the algorithm is, and then we need to figure out a migration plan.

{\bf Risk}: Medium, since a new selection algorithm probably carries
with it a new set of anonymity-breaking papers that will only come out
a few years after we deploy.

{\bf Plan}: Micah is going to write a design proposal for getting
relays to compute and maintain their virtual coordinates based on
latency. Once we deploy that, we'll have some actual data points, and
we'll be in a better position to simulate whether the idea will help
in reality. Counting deployment time, that means we probably won't have
clients using this scheme until 2010.

\subsection{Considering exit policy in relay selection}

When selecting an exit relay for a circuit, the Tor client will build a list
of all exit relays which can carry the desired stream, then select from
them with a probability weighted by each relay's capacity\footnote{The
actual algorithm is slightly more complex: in particular, exit relays which
are also guard relays will be weighted less, and some circuits are
created preemptively without any destination port in mind.}.
This means that relays with more permissive exit policies will be
candidates for more circuits, and hence will be more heavily loaded
compared to relays with restrictive policies.

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{node-selection/exit-capacity}
\caption{Exit relay capacity, in terms of number of relays and advertised
bandwidth for a selection of port numbers.}
\label{fig:exit-capacity}
\end{figure}

\prettyref{fig:exit-capacity} shows the exit relay capacity for a selection
of port numbers.
It can be clearly seen that there is a radical difference in the
availability of relays for certain ports (generally those not in the
default exit policy).
Any traffic to these ports will be routed through a small number of exit
relays, and if they have a permissive exit policy, they will likely become
overloaded from all the other traffic they receive.
The extent of this effect will depend on how much traffic in Tor is to
ports which are not in the default exit policy.

The overloading of permissive exit relays can be counteracted by adjusting
the selection probability of a relay based on its exit policy and knowledge
of the global network load per-port.
While it should improve performance, this modification will make it
easier for malicious exit relays to select traffic they wish to monitor.
For example, an exit relay which wants to attack SSH sessions can currently
list only port 22 in its exit policy.
Currently they will get a small amount of traffic compared to their
capacity, but with the modification they will get a much larger share
of SSH traffic.
(On the other hand, a malicious exit relay could already do this
by artificially
inflating its advertised bandwidth capacity.)

To properly balance exit relay usage, it is necessary to know the usage
of the Tor network, by port.
McCoy \detal~\cite{mccoy-pet2008} have figures for protocol usage in
Tor, but these figures were generated through deep packet inspection,
rather than by port number.
Furthermore, the exit relay they ran used the fairly permissive default
exit policy.
Therefore, their measurements will underestimate the relative traffic on
ports which are present in the default exit policy, and are also present
in more restrictive policies.
To accurately estimate the Tor network usage by port, it is necessary
to measure the network usage by port on one or more exit relays, while
simultaneously recording the exit policy of all other exit relays
considered usable.

We could instead imagine more crude approaches. For example, in
\prettyref{sec:relay-scanning} we suggest using a tool like SpeedRacer
or SoaT to identify relays that are overloaded.  We could then either
instruct clients to avoid them entirely, or reduce the capacity associated
with that relay in the directory status to reduce the attention the relay
gets from clients. Then we could avoid the whole question of \emph{why}
the relays are overloaded. On the other hand, understanding the reasons
for load hotspots can help us resolve them at the architectural level.

{\bf Impact}: Low-medium.

{\bf Effort}: Low-medium.

{\bf Risk}: Low.

{\bf Plan}: When we're gathering statistics for metrics, we should make
a point of gathering some anonymized data about destination ports seen
by a few exit relays. Then we will have better intuition about whether
we should solve this by reweighting at the clients, reweighting in the
directory status, or ignoring the issue entirely.

\subsection{Older entry guards are overloaded}

While the load on exit relays is skewed based on having an unusual exit
policy, load on entry guards is skewed based on how long they've been
in the network.

Since Tor clients choose a small number of entry guards and keep them
for several months, a relay that's been listed with the Guard flag for a
long time will accumulate an increasing number of clients. A relay that
just earned its Guard flag for the first time will see very few clients.

To combat this skew, clients should rotate entry guards every so
often. We need to look at network performance metrics and discern how
long it takes for the skew to become noticeable -- it might be that
rotating to a new guard after a week or two is enough to substantially
resolve the problem. We also need to consider the added risk that
higher guard churn poses versus the original attack they were designed
to thwart~\cite{hs-attack}, but I think a few weeks should still be
plenty high.

At the same time, there are fewer relays with the Guard flag than there
should be. While the Exit flag really is a function of the relay's exit
policy, the required properties for entry guards are much more vague:
we want them to be ``fast enough'', and we want them to be ``likely to
be around for a while more''. I think the requirements currently are too
strict. This scarcity of entry guards in turn influences the anonymity
the Tor network can provide, since there are fewer potential entry points
into the network.

{\bf Impact}: High.

{\bf Effort}: Low.

{\bf Risk}: Low.

{\bf Plan}: We should do it, early in Tor 0.2.2.x. We'll need proposals
first, both for the ``dropping old guards'' plan (to assess the tradeoff
from the anonymity risk) and for the ``opening up the guard criteria''
plan.

%\subsection{Two hops vs three hops.}

% People periodically suggest two hops rather than three. The problem
% is that the design we have right now is more like ``two hops plus an
% entry guard'', so removing any of the hops seems like a bad move.
% But YMMV.

\section{Clients need to handle variable latency and failures better}

The next issue we need to tackle is that Tor clients aren't as good
as they should be at handling high or variable latency and connection
failures. First, we need ways to smooth out the latency that clients see.
Then, for the cases where we can't smooth it out enough, we need better
heuristics for clients to automatically shift away from bad circuits,
and other tricks for them to dynamically adapt their behavior.

\subsection{Our round-robin and rate limiting is too granular}

Tor's rate limiting uses a token bucket approach to enforce a long-term
average rate of incoming and outgoing bytes, while still permitting
short-term bursts above the allowed bandwidth. Each token represents
permission to send another byte onto the network (or read from the
network). Every second new tokens are added, up to some cap (the
\emph{bucket size}).

So Tor relays that have cells buffered waiting to go out onto the network
will wait until the new second arrives, and then deliver as many cells
as they can. In practice, this behavior results in traffic `bumps'
at the beginning of each second, with little network traffic the rest
of the time. Mike and Karsten have been collecting data from circuit
extension times (how long it takes to establish each hop of a circuit);
the bumps are easily seen in \prettyref{fig:extension-times}.

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{extensiontimes}
\caption{Number of seconds it takes to establish each hop of a 3-hop
circuit. The higher density of samples around 2s, 3s, etc indicate that
rate limiting at each relay is introducing extra delay into the
responses.}
\label{fig:extension-times}
\end{figure}

Our original theory when designing Tor's rate limiting was that one-second
granularity should be sufficient:
cells will go out as quickly as possible while the bucket still has
tokens, and once it's empty there's nothing we can do
but wait until the next second for permission to send more cells.

We should explore refilling the buckets more often than once a second,
for three reasons. First, we'll get a better intuition about how full
the buffers really are: if we spread things out better, then we could
reduce latency by perhaps multiple seconds. Second, spikes-and-silence is
not friendly for TCP, so averaging the flows ourselves might mean much
smoother network performance. Third, sub-second precision will give us
more flexibility in our priority strategies from \prettyref{sec:squeeze}.

On the other hand, we don't want to go too far: cells are 512 bytes,
so it isn't useful to think in units smaller than that. Also, every
network write operation carries with it overhead from the TLS record,
the TCP header, and the IP packet header. Finally, network transmission
unit (MTU) sizes vary, but if we could use a larger packet on the wire
and we don't, then we're not being as efficient as we could be.

%also, let's say we have 15 connections that want attention
%and we have n tokens for the second to divide up among them
%and each act of writing onto the connection incurs overhead from tls header
%if we do it on a per-second, we can write more onto a given conn, because we
%have more of n to divvy up
%if we do it every 100ms, we only have n/10 to divvy up, so if we're trying
%to round robin fairly, everybody gets a tinier amount
%in fact, if n is small, and we can't really write less than 512 bytes per
%go, we're going to have to get smarter about randomly picking a conn to use,
%or skipping ones we fed last time, or something. or some will starve
%entirely.
%(right now, i think some starve entirely if you have more than n conns and
%you rate limit to n cells per second)

{\bf Impact}: Low-Medium.

{\bf Effort}: Medium.

{\bf Risk}: Low, unless we add in bad feedback effects and don't notice.

{\bf Plan}: We should continue collecting metrics to get better
intuition here. While we're designing priority stategies for
\prettyref{sec:squeeze}, we should keep the option of higher-resolution
rate-limiting in mind.

%\subsection{The switch to Polipo: prefetching, pipelining, etc}

%Polipo makes Tor appear faster, for some web browsing activities. Yay.
%We should continue our plans to migrate to it. (Polipo needs a more
%active maintainer, and someone with unix to Windows porting experience
%to make polipo work correctly in Windows.  Alternatively, could privoxy
%include some of the polipo features we like?)

\subsection{Better timeouts for giving up on circuits and trying a new one}

Some circuits are established very quickly, and some circuits take many
seconds to form. The time it takes for the circuit to open can give us
a hint about how well that circuit will perform for future traffic. We
should discard extremely slow circuits early, so clients never have to
even try them.

The question, though, is how to decide the right timeouts? If we set a
static timeout in the clients, then choosing a number that's too low will
cause clients to discard too many circuits. Worse, clients on really bad
connections will never manage to establish a circuit. On the other hand,
setting a number that's too high won't change the status quo much.

Fallon Chen worked during her Google-Summer-of-Code-2008 internship with
us on collecting data about how long it takes for clients to establish
circuits, and analyzing the data to decide what shape the distribution
has (it appears to be a Pareto distribution). The goal is for clients
to track their own circuit build times, and then be able to recognize
if a circuit has taken longer than it should have compared to the
previous circuits. That way clients with fast connections can discard
not-quite-fast-enough circuits, whereas clients with slow connections
can discard only the really-very-slow circuits. Not only do clients get
better performance, but we can also dynamically adapt our paths away
from overloaded relays.

Mike and Fallon wrote a
proposal\footnote{\url{https://gitweb.torproject.org/torspec.git/blob/HEAD:/proposals/151-path-selection-improvements.txt}}
explaining the details of how to collect the stats, how many data points
the client needs before it has a good sense of the expected build times,
and so on.

Further, there's another case in Tor where adaptive timeouts would be
smart: how long we wait in between trying to attach a stream to a given
circuit and deciding that we should try a new circuit. Right now we
have a crude and static ``try 10 seconds on one, then try 15 seconds
on another'' algorithm, which is both way too high and way too low,
depending on the context.

{\bf Impact}: Medium.

{\bf Effort}: Medium, but we're already part-way through it.

{\bf Risk}: Low, unless we've mis-characterized the distribution of
circuit extend times, in which case clients end up discarding too many
circuits.

{\bf Plan}: We should deploy the changes in clients in Tor 0.2.2.x to
collect circuit times, and see how that goes. Then we should gather data
about stream timeouts to build a plan for how to resolve the second piece.

%\subsection{When a circuit has too many streams on it, move to a new one}

%This would prevent any single circuit from getting too overloaded.

%But actually, this idea would benefit high-volume flows most, so
%it is a bad idea. We should not do it.

\subsection{If extending a circuit fails, try extending a few other
places before abandoning the circuit.}

Right now, when any extend operation fails, we abandon the entire
circuit. As the reasoning goes, any other approach allows an attacker
who controls some relays (or part of the network) to dictate our circuits
(by declining to extend except to relays that he can successfully attack).

However, this reasoning is probably too paranoid. If we try at most three
times for each hop, we greatly increase the odds that we can reuse the
work we've already done, but we don't much increase the odds that an
attacker will control the entire circuit.

Overall, this modification should cut down on the total number of extend
attempts in the network. This result is particularly helpful since some
of our other schemes in this document involve increasing that number.

{\bf Impact}: Low.

{\bf Effort}: Low.

{\bf Risk}: Low-medium. We need to actually do some computations to
confirm that the risk of whole-path compromise is as low as we think
it is.

{\bf Plan}: Do the computations, then write a proposal, then do it.

\subsection{Improving efficiency of the Tor circuit-building protocol}
\label{sec:protocol-efficiency}

A number of proposals~\cite{kate-pet2007,overlier:pet2007} have been
published in the literature on how to improve the efficiency of the Tor
handshake protocol.
These would reduce the latency of circuit establishment, and lower CPU
load on nodes.
Applying a modification like this would break existing clients, so
Tor's version negotiation functionality would be required to permit both
protocol to operate in parallel.
Compared to the existing Tor protocol, the proposed modifications are not
as well analyzed so there is a risk that they will have some weaknesses.
Some also relax Tor's security assurances (e.g. perfect forward secrecy)
in order to offer improved performance.

{\bf Impact}: Low.

{\bf Effort}: High.

{\bf Risk}: High.

{\bf Plan}: Not yet. Cryptographic overhead does not appear to be a
significant component of latency. If, later on, circuit establishment
overhead starts to be a significant contributor to performance problems,
we should re-evaluate.

\subsection{Bundle the first data cell with the begin cell}

In Tor's current design, clients send a ``relay begin'' cell to specify
the intended destination for our stream, and then wait for a ``relay
connected'' cell to confirm the connection is established. Only then
do they complete the SOCKS handshake with the local application, and
start reading application traffic.

We could modify our local proxy protocol in the case of Privoxy or Polipo
so it sends the web request to the SOCKS port during the handshake. Then
we could optimistically include the first cell worth of application data
in the original begin cell. This trick would allow us to cut out an entire
network round-trip every time we establish a new connection through Tor.
The result would be quicker page loads for users.

Alas, this trick would involve extending the SOCKS protocol, which isn't
usually a polite strategy when it comes to interoperating with other
applications. On the other hand, it should be possible to extend it in a
backwards-compatible way: applications that don't know about the trick
would still behave the same and still work fine (albeit in a degraded
mode where they waste a network round-trip).

{\bf Impact}: Medium.

{\bf Effort}: Medium.

{\bf Risk}: Low.

{\bf Plan}: Overall, it seems like a delicate move, but with potentially
quite a good payoff. I'm not convinced yet either way.

\section{The network overhead may still be high for modem users}

Even if we resolve all the other pieces of the performance question,
there still remain some challenges posed uniquely by users with extremely
low bandwidth -- for example, users on modems or cell phones. We need
to optimize the Tor protocols so they are efficient enough that Tor can
be practical in this situation too.

\subsection{We've made progress already at directory overhead}
\label{sec:directory-overhead}

We've already made great progress at reducing directory
overhead, both for bootstrapping and maintenance. Our
blog post on the topic provides background and
details\footnote{\url{https://blog.torproject.org/blog/overhead-directory-info\%3A-past\%2C-present\%2C-future}}.

Proposal 158 further reduces the directory overhead, and is scheduled
to be deployed in Tor 0.2.2.x.\footnote{\url{https://gitweb.torproject.org/torspec.git/blob/HEAD:/proposals/158-microdescriptors.txt}}

{\bf Impact}: Low for normal users, high for low-bandwidth users.

{\bf Effort}: Medium, but we're already a lot of the way through it.

{\bf Risk}: Low.

{\bf Plan}: We should roll out proposal 158. Then we'll be in good
shape for a while. The next directory overhead challenge will be in
advertising many more relays; but first we need to get the relays.

\subsection{Our TLS overhead can also be improved}

OpenSSL will, by default, insert an empty TLS application record before
any one which contains data.
This is to prevent an attack, by which someone who has partial control
over the plaintext of a TLS stream, can also confirm guesses as to the
plaintext which he does not control.
By including an empty application record, which incorporates a MAC,
the attacker is made unable to control the CBC initialization vector,
and hence does not have control of the input to the encryption
function~\cite{tls-cbc}.

This application record does introduce an appreciable overhead.
Most Tor cells are sent in application records of their own, giving
application records of 512 bytes (cell) $+$ 20 bytes (MAC) $+$ 12 bytes
(TLS padding) $+$ 5 bytes (TLS application record header) $=$ 549 bytes.
The empty application records contain only 20 bytes (MAC) $+$ 12 bytes
(TLS padding) $+$ 5 bytes (TLS application record header) $=$ 37 bytes.
There is also a 20 byte IP header and 32 byte TCP header.

Thus the overhead saved by removing the empty TLS application record
itself is $37 / (549 + 37 + 20 + 32) = 5.8\%$.
This calculation is assuming that the same number of IP packets will
be sent, because currently Tor sends packets, with only one cell, far
smaller than the path MTU.
If Tor were to pack cells optimally efficiently into packets, then
removing the empty application records would also reduce the number of
packets, and hence TCP/IP headers, that needed to be sent.
The reduction in TCP/IP header overhead would be $37/(549 + 37) = 6.3\%$.

Of course, the empty application record was inserted for a reason --
to prevent an attack on the CBC mode of operation used by TLS, so before
removing it we must be confident the attack does not apply to Tor.
Ben Laurie (one of the OpenSSL developers) concluded that in his
opinion Tor could safely remove the insertion of empty TLS application
records~\cite{tls-empty-record}.
Steven was able to come up with only certificational weaknesses (discussed
in the above analysis), which are expensive to exploit and give little
information to the attacker.

%To be successful, the attacker must have full control of the plaintext
%application record before the one he wishes to guess.
%Tor makes this difficult because all cells where the payload is controlled
%by the attacker are prepended with a two byte circuit ID, unknown to
%the attacker.
%Also, because the majority of cells sent in Tor are encrypted by a key
%not known by the attacker, the probability that an attacker can guess
%what a cell might be is extremely small.
%The exception is a padding cell, which has no circuit ID and a zero
%length payload, however Tor does not currently send padding cells,
%other than as a periodic keep-alive.

{\bf Impact}: Low.

{\bf Effort}: Low.

{\bf Risk}: Medium, since our initial analysis might be wrong.

{\bf Plan}: Do it in the Tor 0.2.2.x or 0.2.3.x timeframe. Not critical.

%\subsection{Hibernating relays shouldn't be listed as Running}

%we are giving Running flags to hibernating relays. if we stop giving
%them the Running flag, they will no longer get into the consensus,
%thus saving directory overhead. but this is simply a bug that we
%should fix.

\section{Last thoughts}

\subsection{Lessons from economics}
\label{sec:economics}

Imagine we implement all the solutions above, and it doubles the effective
capacity of the Tor
network. The na\"{\i}ve hypothesis is that users would then experience
twice the throughput.
Unfortunately this is not true, because it assumes that the number of
users does not vary with bandwidth available.
In fact, as the supply of the Tor network's bandwidth increases, there
will be a corresponding increase in the demand for bandwidth from
Tor users.
Simple economics shows that performance of Tor and other
anonymization networks is controlled by how the number of users
scales with available bandwidth; this relationship can be represented
by a demand
curve.\footnote{The economics discussion is based on a blog post published
in Light
Blue Touchpaper~\cite{economics-tor}. The property discussed was also
observed by Andreas Pfitzmann in response to a presentation at the PET
Symposium~\cite{wendolsky-pet2007}.}

\begin{figure}[t]
\centering
\includegraphics[width=0.6\textwidth]{equilibrium}
\caption{Hypothetical supply and demand curves for Tor network
resources. As supply goes up, point A corresponds to no increase in users,
whereas points B and C represent more users arriving to use up some of
the new capacity.}
\label{fig:equilibrium}
\end{figure}

\prettyref{fig:equilibrium} is the typical supply and demand graph from
economics textbooks, except with long-term throughput per user substituted
for price, and number of users substituted for quantity of goods sold.
%Also, it is inverted, because users prefer higher throughput, whereas
%consumers prefer lower prices.
%Similarly,
As the number of users increases, the bandwidth supplied
by the network falls.
%, whereas suppliers will produce more goods if the price is higher.

In drawing the supply curve, we have assumed the network's bandwidth is
constant and shared equally over as many users as needed.
The shape of the demand curve is much harder to even approximate, but
for the sake of discussion, we have drawn three alternatives.
The number of Tor users and the throughput they each get is the
intersection between the supply and demand curves -- the equilibrium.
If the number of users is below this point, more users will join and
the throughput per user will fall to the lowest tolerable level.
Similarly, if the number of users is too high, some will be getting
lower throughput than their minimum, so will give up, improving the
network for the rest of the users.

Now assume Tor's bandwidth grows by 50\% -- the supply curve shifts,
as shown in the figure.
By comparing how the equilibrium moves, we can see how the shape of the
demand curve affects the performance improvement that Tor users see.
If the number of users is independent of performance, shown in curve A,
then everyone gets a 50\% improvement, which matches the na\"{\i}ve
hypothesis.
More realistically, the number of users increases, so the performance
gain is less. The shallower the curve gets, the smaller the performance
increase will be.
For demand curve B, there is a 18\% increase in the number of Tor users
and a 27\% increase in throughput. On the other hand, with curve C there
are 33\%
more users and so only a 13\% increase in throughput for each user.

%In an extreme case where the demand curve points down (not shown),
%as the network bandwidth increases, performance for users will fall.
%Products exhibiting this type of demand curve, such as designer clothes,
%are known as Veblen goods.
%As the price increases, their value as status symbols grows, so more
%people want to buy them.
%I don't think it is likely to be the case with Tor, but there could be
%a few users who might think that the slower the network is, the better
%it is for anonymity.

%To keep the explanation simple, I have made quite a few assumptions,
%some more reasonable than others.
%For the supply curve, I assume that all Tor's bandwidth goes into
%servicing user requests, it is shared fairly between users, there is
%no overhead when the number of Tor clients grows, and the performance
%bottleneck is the network, not clients.
%I don't think any of these are true, but the difference between the ideal
%case and reality might not be significant enough to nullify the analysis.
%The demand curves are basically guesswork -- it's unlikely that the true
%one is as nicely behaved as the ideal ones shown.
%It more likely will be a combination of the different classes, as
%different user communities come into relevance.

The above analysis glosses over many topics. One interesting analysis
is reaching equilibrium -- in fact it could
take some time between the network bandwidth changing and the user
population reaching stability.
If this period is sufficiently long and network bandwidth is sufficiently
volatile it might never reach equilibrium.
We might also consider effects which shift the demand curve.
In normal economics, marketing makes people buy a product even though
they considered it too expensive.
Similarly, a Slashdot article or news of a privacy scandal could make
Tor users more tolerant of the poor performance.
Finally, the user perception of performance is an interesting and complex
topic. In this analyis
we assumed that performance is equivalent to throughput; but actually
latency, packet loss, predictability, and their interaction with TCP/IP
congestion control are important components too.

So what does all this tell us?

The above discussion has argued that the speed of an anonymity network
will converge on the slowest level that the most tolerant users will
consider usable.
This is problematic because there is significant variation in levels
of tolerance between different users and different protocols.
Most notably, file sharing users are subject to high profile legal
threats, and do not require interactive traffic, so they will continue to use
a network even if the performance is considerably lower than the usable
level for web browsing.

In conventional markets, this type of problem is solved by differential
pricing, for example different classes of seat on airline flights.
In this model, several equilibrium points are allowed to form, and the
one chosen will depend on the cost/benefit tradeoffs of the customers.
A similar strategy could be used for Tor, allowing interactive web
browsing users to get higher performance, while forcing bulk data transfer
users to have lower performance (but still tolerable for them).
Alternatively, the network could be configured to share resources in a
manner such that the utility to each user is more equal.
In this case, it will be acceptable to all users that a single equilibrium
point is formed, because its level will no longer be characterized in
terms of simple bandwidth.

\prettyref{sec:too-much-load} is an example of the former strategy.
Web browsing users will be offered better performance, so we should
attract more of them, but hopefully not so many that the performance
returns to current levels.
In constrast, bulk-traffic users will be given poorer performance,
but since they are less sensitive to latency, it could be that they do
not mind.
\prettyref{sec:congestion} could be used to implement the latter strategy.
If web-browsing users are more sensitive to latency than bandwidth,
then we could optimize the network for latency rather than throughput.

\subsection{The plan moving forward}

Our next steps should be to work with funders and developers to turn
this set of explanations and potential fixes into a roadmap: we need to
lay out all the solutions, sort out the dependencies, assign developers
to tasks, and get everything started.

At the same time, we need to continue to work on ways to measure changes
in the network: without `before' and `after' snapshots, we'll have
a much tougher time telling whether a given idea is actually working.
Many of the plans here have a delay between when we roll out the change
and when the clients and relays have upgraded enough for the change to
be noticeable. Since our timeframe requires rolling out several solutions
at the same time, an increased focus on metrics and measurements will be
critical to keeping everything straight.

Lastly, we need to be aware that ramping up development on performance
may need to push out or downgrade other items on our roadmap. So far,
Tor has been focusing our development energy on the problems that funders
are experiencing most severely at the time. This approach is good to make
sure that we're always working on something that's actually important.
But it also means that next year's critical items don't get as much
attention as they should, and last year's critical items don't get
as much maintenance as they should. Ultimately we need to work toward
having consistent funding for core Tor development and maintenance as
well as feature-oriented funding.

%\subsection*{Acknowledgements}

% Mike Perry provided many of the ideas discussed here

\bibliography{performance}

\end{document}

